grails-app/domain/net/okjsp/Company.groovy
package net.okjsp

class Company {

    String name
    String logo

    String registerNumber

    Person manager

    Date dateCreated = new Date()
    Date lastUpdated

    boolean enabled = false
    boolean locked = false

    static hasMany = [members : Person]

    static constraints = {
        logo nullable: true
        name blank: false, unique: true
    }
    
    static mapping = {
        cache true
    }
}

grails-app/controllers/net/okjsp/AdminCompanyController.groovy
package net.okjsp

import grails.plugin.mail.MailService

import static org.springframework.http.HttpStatus.*
import grails.transaction.Transactional

@Transactional(readOnly = true)
class AdminCompanyController {

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    MailService mailService

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        params.order = params.order ?: 'desc'
        params.sort = params.sort ?: 'id'


        def list, count

        if(params.where) {

            def companies = Company.where {
                name =~ "%${params.where}%" ||
                registerNumber =~ "%${params.where}%"
            }

            list = companies.list(params)
            count = companies.count()

        } else {
            list = Company.list(params)
            count = Company.count()
        }

        respond list, model:[companyCount: count]
    }

    def show(Company company) {
        def companyInfo = CompanyInfo.findByCompany(company)

        def user = User.findByPerson(company.manager)

        respond company, model: [companyInfo: companyInfo, user: user]
    }

    def create() {
        respond new Company(params)
    }

    @Transactional
    def save(Company company) {
        if (company == null) {
            notFound()
            return
        }

        if (company.hasErrors()) {
            respond company.errors, view:'create'
            return
        }

        company.save flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'company.label', default: 'Company'), company.id])
                redirect company
            }
            '*' { respond company, [status: CREATED] }
        }
    }

    def edit(Company company) {
        respond company
    }

    @Transactional
    def update(Company company) {
        if (company == null) {
            notFound()
            return
        }

        if (company.hasErrors()) {
            respond company.errors, view:'edit'
            return
        }

        company.save flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'Company.label', default: 'Company'), company.id])
                redirect uri: '/_admin/company/show/'+company.id
            }
            '*'{ respond company, [status: OK] }
        }
    }

    @Transactional
    def delete(Company companyInstance) {

        if (companyInstance == null) {
            notFound()
            return
        }

        Person.where {
            company == companyInstance
        }.updateAll(company: null)

        CompanyInfo.where {
            company == companyInstance
        }.deleteAll()

        companyInstance.delete flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'Company.label', default: 'Company'), companyInstance.id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    @Transactional
    def enable(Company company) {
        if (company == null) {
            notFound()
            return
        }

        def companyInfo = CompanyInfo.findByCompany(company)

        company.enabled = true
        company.save flush: true


        mailService.sendMail {
            async true
            to companyInfo?.email, companyInfo.managerEmail
            from "OKKY JOBS <jobs@okky.kr>"
            subject "["+message(code:'email.company.enabled.subject')+"] ${company.name}의 회사정보 인증이 완료되었습니다."
            body(view:'/email/company_enabled', model: [company: company, companyInfo: companyInfo, grailsApplication: grailsApplication] )
        }

        flash.message = message(code: 'default.updated.message', args: [message(code: 'Company.label', default: 'Company'), company.id])
        redirect uri: '/_admin/company/show/'+company.id
    }

    @Transactional
    def disable(Company company) {
        if (company == null) {
            notFound()
            return
        }

        company.enabled = false
        company.save flush: true

        flash.message = message(code: 'default.updated.message', args: [message(code: 'Company.label', default: 'Company'), company.id])
        redirect uri: '/_admin/company/show/'+company.id

    }

    protected void notFound() {
        request.withFormat {
            form  {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'company.label', default: 'Company'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }
}

grails-app/views/adminCompany/_form.gsp
<%@ page import="net.okjsp.Company" %>



<div class="fieldcontain ${hasErrors(bean: company, field: 'logo', 'error')} ">
	<label for="logo">
		<g:message code="company.logo.label" default="Logo" />
		
	</label>
	<g:textField name="logo" value="${company?.logo}"/>

</div>

<div class="fieldcontain ${hasErrors(bean: company, field: 'name', 'error')} required">
	<label for="name">
		<g:message code="company.name.label" default="Name" />
		<span class="required-indicator">*</span>
	</label>
	<g:textField name="name" required="" value="${company?.name}"/>

</div>

<div class="fieldcontain ${hasErrors(bean: company, field: 'enabled', 'error')} ">
	<label for="enabled">
		<g:message code="company.enabled.label" default="Enabled" />
		
	</label>
	<g:checkBox name="enabled" value="${company?.enabled}" />

</div>


</div>

grails-app/views/adminCompany/create.gsp
<!DOCTYPE html>
<html>
	<head>
		<meta name="layout" content="admin">
		<g:set var="entityName" value="${message(code: 'company.label', default: 'Company')}" />
		<title><g:message code="default.create.label" args="[entityName]" /></title>
	</head>
	<body>
		<a href="#create-company" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
		<div class="nav" role="navigation">
			<ul>
				<li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
				<li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
			</ul>
		</div>
		<div id="create-company" class="content scaffold-create" role="main">
			<h1><g:message code="default.create.label" args="[entityName]" /></h1>
			<g:if test="${flash.message}">
			<div class="message" role="status">${flash.message}</div>
			</g:if>
			<g:hasErrors bean="${company}">
			<ul class="errors" role="alert">
				<g:eachError bean="${company}" var="error">
				<li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
				</g:eachError>
			</ul>
			</g:hasErrors>
			<g:form url="[resource:company, action:'save']" >
				<fieldset class="form">
					<g:render template="form"/>
				</fieldset>
				<fieldset class="buttons">
					<g:submitButton name="create" class="save" value="${message(code: 'default.button.create.label', default: 'Create')}" />
				</fieldset>
			</g:form>
		</div>
	</body>
</html>

grails-app/views/adminCompany/edit.gsp
<%@ page import="net.okjsp.Company" %>
<!DOCTYPE html>
<html>
	<head>
		<meta name="layout" content="admin">
		<g:set var="entityName" value="${message(code: 'company.label', default: 'Company')}" />
		<title><g:message code="default.edit.label" args="[entityName]" /></title>
	</head>
	<body>
		<a href="#edit-company" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
		<div class="nav" role="navigation">
			<ul>
				<li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
				<li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
				%{--<li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>--}%
			</ul>
		</div>
		<div id="edit-company" class="content scaffold-edit" role="main">
			<h1><g:message code="default.edit.label" args="[entityName]" /></h1>
			<g:if test="${flash.message}">
			<div class="message" role="status">${flash.message}</div>
			</g:if>
			<g:hasErrors bean="${company}">
			<ul class="errors" role="alert">
				<g:eachError bean="${company}" var="error">
				<li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
				</g:eachError>
			</ul>
			</g:hasErrors>
			<g:form url="[uri: '/_admin/company/update/'+company.id]" method="PUT" >
				<g:hiddenField name="version" value="${company?.version}" />
				<fieldset class="form">
					<g:render template="form"/>
				</fieldset>
				<fieldset class="buttons">
					<g:actionSubmit class="save" action="update" value="${message(code: 'default.button.update.label', default: 'Update')}" />
				</fieldset>
			</g:form>
		</div>
	</body>
</html>

grails-app/views/adminCompany/index.gsp
<%@ page import="net.okjsp.Company" %>
<!DOCTYPE html>
<html>
	<head>
		<meta name="layout" content="admin">
		<g:set var="entityName" value="${message(code: 'company.label', default: 'Company')}" />
		<title><g:message code="default.list.label" args="[entityName]" /></title>
	</head>
	<body>
		<a href="#list-company" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
		<div class="nav" role="navigation">
			<ul>
				<li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
				%{--<li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>--}%
			</ul>
		</div>
		<div id="list-company" class="content scaffold-list" role="main">
			<h1><g:message code="default.list.label" args="[entityName]" /></h1>
			<div class="search-form">
				<form name="searchForm">
					<div class="input-group">
						<input type="search" class="form-control" name="where" value="${params.where}" placeholder="검색어 (회사명, 사업자등록번호)" />
						<span class="input-group-btn">
							<button type="submit" class="btn btn-default">검색</button>
							<g:if test="${params.where}">
								<g:link action="index" class="btn btn-warning">clear</g:link>
							</g:if>
						</span>
					</div>
				</form>
			</div>
			<g:if test="${flash.message}">
				<div class="message" role="status">${flash.message}</div>
			</g:if>
			<table>
			<thead>
					<tr>
					
						<g:sortableColumn property="logo" title="${message(code: 'company.logo.label', default: 'Logo')}" />
					
						<g:sortableColumn property="name" title="${message(code: 'company.name.label', default: 'Name')}" />
					
						<th><g:message code="company.manager.label" default="Manager" /></th>

						<g:sortableColumn property="enabled" title="${message(code: 'company.enabled.label', default: 'Enabled')}" />

						<g:sortableColumn property="locked" title="${message(code: 'company.locked.label', default: 'Locked')}" />

					</tr>
				</thead>
				<tbody>
				<g:each in="${companyList}" status="i" var="company">
					<tr class="${(i % 2) == 0 ? 'even' : 'odd'}">

						<td><g:link action="show" id="${company.id}"><img src="${grailsApplication.config.grails.fileURL}/logo/${fieldValue(bean: company, field: "logo")}" width="20" height="20" /></g:link></td>

						<td><g:link action="show" id="${company.id}">${fieldValue(bean: company, field: "name")}</g:link></td>

						<td>${fieldValue(bean: company, field: "manager")}</td>

						<td><strong><g:formatBoolean boolean="${company.enabled}" true="인증됨" false="인증안됨" /></strong></td>

						<td><strong><g:formatBoolean boolean="${company.locked}" true="블록됨" false="정상" /></strong></td>

					</tr>
				</g:each>
				</tbody>
			</table>
			<div class="admin-pagination">
				<g:paginate total="${companyCount ?: 0}" />
			</div>
		</div>
	</body>
</html>

grails-app/views/adminCompany/show.gsp
<%@ page import="net.okjsp.Company" %>
<!DOCTYPE html>
<html>
	<head>
		<meta name="layout" content="admin">
		<g:set var="entityName" value="${message(code: 'company.label', default: 'Company')}" />
		<title><g:message code="default.show.label" args="[entityName]" /></title>
	</head>
	<body>
		<a href="#show-company" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
		<div class="nav" role="navigation">
			<ul>
				<li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
				<li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
				%{--<li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>--}%
			</ul>
		</div>
		<div id="show-company" class="content scaffold-show" role="main">
			<h1><g:message code="default.show.label" args="[entityName]" /></h1>
			<g:if test="${flash.message}">
			<div class="message" role="status">${flash.message}</div>
			</g:if>
			<ol class="property-list company">
			
				<g:if test="${company?.logo}">
				<li class="fieldcontain">
					<span id="logo-label" class="property-label"><g:message code="company.logo.label" default="Logo" /></span>
					
						<span class="property-value" aria-labelledby="logo-label"><img src="${grailsApplication.config.grails.fileURL}/logo/${fieldValue(bean: company, field: "logo")}" width="40" height="40" /></span>
					
				</li>
				</g:if>
			
				<g:if test="${company?.name}">
				<li class="fieldcontain">
					<span id="name-label" class="property-label"><g:message code="company.name.label" default="Name" /></span>
					
					<span class="property-value" aria-labelledby="name-label"><g:link uri="/company/info/${company?.id}" target="_new"><g:fieldValue bean="${company}" field="name"/></g:link></span>
					
				</li>
				</g:if>

				<g:if test="${company?.registerNumber}">
					<li class="fieldcontain">
						<span id="registerNumber-label" class="property-label"><g:message code="company.registerNumber.label" default="사업자등록번호" /></span>

						<span class="property-value" aria-labelledby="registerNumber-label"><g:fieldValue bean="${company}" field="registerNumber"/></span>

					</li>
				</g:if>
			
				<li class="fieldcontain">
					<span id="enabled-label" class="property-label"><g:message code="company.enabled.label" default="Enabled" /></span>
					
						<span class="property-value" aria-labelledby="enabled-label"><strong><g:formatBoolean boolean="${company.enabled}" true="인증됨" false="인증안됨" /></strong></span>
					
				</li>

				<g:if test="${company?.locked}">
				<li class="fieldcontain">
					<span id="locked-label" class="property-label"><g:message code="company.locked.label" default="Locked" /></span>

					<span class="property-value" aria-labelledby="locked-label"><g:formatBoolean boolean="${company?.locked}" /></span>

				</li>
				</g:if>

				<g:if test="${company?.manager}">
				<li class="fieldcontain">
					<span id="manager-label" class="property-label"><g:message code="company.manager.label" default="Manager" /></span>
					
						<span class="property-value" aria-labelledby="manager-label"><g:link uri="/_admin/user/show/${user?.id}">${company?.manager?.encodeAsHTML()}</g:link></span>
					
				</li>
				</g:if>
			
			</ol>
			<div id="show-company" class="content scaffold-show" role="main">
			<h1><g:message code="default.show.label" args="['Company Info']" /></h1>
			<ol class="property-list company">

				<li class="fieldcontain">
					<span id="tel-label" class="property-label"><g:message code="companyInfo.tel.label" default="연락처" /></span>

					<span class="property-value" aria-labelledby="tel-label"><g:fieldValue bean="${companyInfo}" field="tel"/></span>

				</li>

				<li class="fieldcontain">
					<span id="email-label" class="property-label"><g:message code="companyInfo.email.label" default="이메일" /></span>

					<span class="property-value" aria-labelledby="email-label"><g:fieldValue bean="${companyInfo}" field="email" /></span>

				</li>

				<li class="fieldcontain">
					<span id="managerName-label" class="property-label"><g:message code="companyInfo.managerName.label" default="담당자명" /></span>

					<span class="property-value" aria-labelledby="managerName-label"><g:fieldValue bean="${companyInfo}" field="managerName" /></span>

				</li>

				<li class="fieldcontain">
					<span id="managerTel-label" class="property-label"><g:message code="companyInfo.managerTel.label" default="담당자 연락처" /></span>

					<span class="property-value" aria-labelledby="managerTel-label"><g:fieldValue bean="${companyInfo}" field="managerTel"/></span>

				</li>

				<li class="fieldcontain">
					<span id="managerEmail-label" class="property-label"><g:message code="companyInfo.managerEmail.label" default="이메일" /></span>

					<span class="property-value" aria-labelledby="managerEmail-label"><g:fieldValue bean="${companyInfo}" field="managerEmail" /></span>

				</li>

				<li class="fieldcontain">
					<span id="homepageUrl-label" class="property-label"><g:message code="companyInfo.homepageUrl.label" default="홈페이지" /></span>

					<span class="property-value" aria-labelledby="homepageUrl-label"><g:fieldValue bean="${companyInfo}" field="homepageUrl" /></span>

				</li>

				<li class="fieldcontain">
					<span id="employeeNumber-label" class="property-label"><g:message code="companyInfo.employeeNumber.label" default="직원 수" /></span>

					<span class="property-value" aria-labelledby="employeeNumber-label">
						<g:message code="companyInfo.employeeNumber.value_${companyInfo.employeeNumber}" />
					</span>

				</li>

				<li class="fieldcontain">
					<span id="introFile-label" class="property-label"><g:message code="companyInfo.introFile.label" default="사업자등록증" /></span>

					<span class="property-value" aria-labelledby="introFile-label">
						<g:if test="${companyInfo.introFile != null}">
							<a href="${grailsApplication.config.grails.fileURL}/intro/${companyInfo.introFile.name}">${companyInfo.introFile.orgName}</a>
						</g:if>
						<g:else>
							없음
						</g:else>
					</span>

				</li>


				<li class="fieldcontain">
					<span id="introduce-label" class="property-label"><g:message code="companyInfo.introduce.label" default="회사소개" /></span>

					<span class="property-value" aria-labelledby="introduce-label">
						<g:filterHtml text="${companyInfo.description}" />
					</span>

				</li>



			</ol>
			<g:form url="[uri: '/_admin/company/delete/'+company.id]" method="DELETE">
				<fieldset class="buttons">
					<g:link class="edit"  uri="/_admin/company/edit/${company.id}"><g:message code="default.button.edit.label" default="Edit" /></g:link>
					<g:actionSubmit class="delete" controller="adminCompany" action="delete" value="${message(code: 'default.button.delete.label', default: 'Delete')}" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
					|
					<g:if test="${company.enabled}">
						<g:link class="delete" uri="/_admin/company/disable/${company.id}" ><g:message code="company.button.disable.label" default="Disable" onClick="return confirm('해당 회사 인증을 취소 하시겠습니까?');"/></g:link>
					</g:if>
					<g:else>
						<g:link class="save" uri="/_admin/company/enable/${company.id}"  onClick="return confirm('해당 회사 인증을 하시겠습니까?');"><g:message code="company.button.enable.label" default="Enable"  /></g:link>
					</g:else>
				</fieldset>
			</g:form>
		</div>
	</body>
</html>